var getAst = require("./get_ast");
var amdToAmd = require("./amd_amd");
var getCompile = require("./es6_compiler");
var patchCircularDependencies = require("./patch_circular_dependencies");

module.exports = function(load, options) {
	var compile = getCompile(options);

	var result = compile(
		load.source.toString(),
		{
			filename: options.sourceMapFileName || load.address,
			modules: "amd",
			sourceMaps: true
		},
		options
	);

	load.source = result.code;
	load.map = result.map;
	load.ast = getAst(load, options.sourceMapFileName);

	if (load.circular && options.patchCircularDependencies) {
		load.ast = patchCircularDependencies(load.ast);
	}

	return amdToAmd(load, options);
};
